//  Created by dasdom on 19.01.20.
//  Copyright © 2020 dasdom. All rights reserved.
//

import UIKit
import CoreLocation
import LogStore
import Combine

class LocationProvider: NSObject, CLLocationManagerDelegate {

  private let locationManager: CLLocationManager
  @Published var lastLocation: CLLocation?

  override init() {
    
    locationManager = CLLocationManager()
    
    super.init()
    
    locationManager.delegate = self
    locationManager.requestWhenInUseAuthorization()
  }
  
  func start() {
    locationManager.startUpdatingLocation()
  }
  
  func stop() {
    locationManager.stopUpdatingLocation()
  }
  
  func locationManager(_ manager: CLLocationManager,
                       didChangeAuthorization status: CLAuthorizationStatus) {
    
    switch status {
    case .authorizedWhenInUse:
      printLog("success")
    default:
      // ToDo: implement
      break
    }
  }
  
  func locationManager(_ manager: CLLocationManager,
                       didUpdateLocations locations: [CLLocation]) {
    
    lastLocation = locations.last
    printLog("accuracy: \(String(describing: lastLocation?.horizontalAccuracy))")
  }
}
