//  Created by dasdom on 18.01.20.
//  Copyright © 2020 dasdom. All rights reserved.
//

import SpriteKit
import ARKit

let textAnchorName = "textAnchorName"

class Scene: SKScene {
  
  override func didMove(to view: SKView) {
    // Setup your scene here
  }
  
  override func update(_ currentTime: TimeInterval) {
    // Called before each frame is rendered
  }
  
  override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
    guard let sceneView = self.view as? ARSKView else {
      return
    }
    
    guard let touch = touches.first else { return }
    let point = touch.location(in: sceneView)
    guard let hitTestResult =
      sceneView.hitTest(point, types: .existingPlane).first else {
        return
    }
    
    let anchor = ARAnchor(name: textAnchorName,
                          transform: hitTestResult.worldTransform)
    sceneView.session.add(anchor: anchor)
  }
}
